//  ATiny2313  indic22mega8 
//  :  0  
//ATiny2313
//     

// CodeVisionAVR C Compiler
// (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATtiny2313


#pragma used+
#pragma used+
sfrb DIDR=1;
sfrb UBRRH=2;
sfrb UCSRC=3;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb USICR=0xd;
sfrb USISR=0xe;
sfrb USIDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb GPIOR0=0x13;
sfrb GPIOR1=0x14;
sfrb GPIOR2=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEAR=0x1e;
sfrb PCMSK=0x20;
sfrb WDTCR=0x21;
sfrb TCCR1C=0x22;
sfrb GTCCR=0x23;
sfrb ICR1L=0x24;
sfrb ICR1H=0x25;
sfrw ICR1=0x24;   // 16 bit access
sfrb CLKPR=0x26;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;   // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;   // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb TCCR0A=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0B=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb OCR0A=0x36;
sfrb SPMCSR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb EIFR=0x3a;
sfrb GIMSK=0x3b;
sfrb OCR0B=0x3c;
sfrb SPL=0x3d;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// for compatibility with the interrupt vector names from Atmel's datasheet


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


unsigned char number[] = 
{
  0b00111111, //0   0b00111111
  0b00000110, //1   0b00000110
  0b01011011, //2   0b01011011
  0b01001111, //3   0b01001111
  0b01100110, //4   0b01100110
  0b01101101, //5   0b01101101
  0b01111101, //6   0b01111101
  0b00000111, //7   0b00000111
  0b01111111, //8   0b01111111
  0b01101111,  //9   0b01101111 
  0b00111111
};

//    
unsigned char data_e=0;   //1  
unsigned char data_d=0;   //2  
unsigned char count=0;

//  0 -   
interrupt [7] void Timer0Ovf(void)
{
  //  
   PORTD.0=PORTD.1=1;            //..  1
   //  
   if (count==0) 
    {
      PORTB=number[data_d];     // 
     PORTD.1=~PORTD.1;          //
    }       
   
   if (count==1) 
    {
      PORTB=number[data_e]; 
      PORTD.0=~PORTD.0;         //
    }                         
    count++;
    
    if (count==2) count=0;
   TCNT0=175;  //178
}

void main( void )
{
  //,   . 
   DDRB=0b11111111;        //0b11111111
  PORTB=0b00000000;        //0b11111111
  
  //,   . 
   DDRD=0b0000011;       //PD.0,PD.1  
  PORTD=0b1100000;       //PIND.5 . 
                         //PIND.6 . 
  //  0              
  TIMSK=0b00000010;             // . 0 bit 1  
  TCCR0B=0b00000101;            //  4000/1024=3,90625 
  TCNT0=175;                    //178
    
  while(1)
  {
      //  
  if (PIND.6==0)              //. 
    {
      data_e++;               // 
      if (data_e==10)         //  =10
        {
          data_e=0;           //   0
          data_d++;           //  
        }                         
      delay_ms(200);          //
    } 
    
   if (PIND.5==0)             //.  
      {
      data_e--;               // 
      if (data_e==0)          //  =0
        {    
          data_e=10;         
        }//if2
       if (data_e==9) data_d=data_d-1;
      delay_ms(200);
      }     
    #asm("sei");
   }//while(1)   
}//main
